
#ifndef _SERVERSVC_H_
#define _SERVERSVC_H_
// ----------------------------------------------------------------------------

#include "WinService.h"

class DDSDomainParticipant;
class DDSSubscriber;
class DDSTopic;
class HelloWorldListener;
class DDSDataReader;

class HelloSvc : public WinSvc
{
public:
	HelloSvc(const tstring& tsName, const tstring& tsEventLogDLL);
	~HelloSvc();

	virtual void OnRun();
	virtual void OnStop();

	int SubscriberMain(int domainId, int sample_count);
	int SubscriberShutdown(DDSDomainParticipant *participant);

	void SetDomainID(int domainID);
	void SetSampleCount(int sample_count);

private:
	int m_nDomainID;
	int m_nSampleCount;

	DDSDomainParticipant *participant;
	DDSSubscriber *subscriber;
	DDSTopic *topic;
	HelloWorldListener *reader_listener; 
	DDSDataReader *reader;
};

// ----------------------------------------------------------------------------
#endif //!_SERVERSVC_H_
// ----------------------------------------------------------------------------
