#include <stdio.h>
#include <stdlib.h>
#include "HelloSvc.h"

extern "C" int subscriber_main(int domainId, int sample_count);

#if defined(RTI_WINCE)
int wmain(int argc, wchar_t** argv)
{
	int domainId = 0;
	int sample_count = 0; /* infinite loop */ 

	if (argc >= 2) {
		domainId = _wtoi(argv[1]);
	}
	if (argc >= 3) {
		sample_count = _wtoi(argv[2]);
	}

	/* Uncomment this to turn on additional logging
	NDDSConfigLogger::get_instance()->
	set_verbosity_by_category(NDDS_CONFIG_LOG_CATEGORY_API, 
	NDDS_CONFIG_LOG_VERBOSITY_STATUS_ALL);
	*/

	return subscriber_main(domainId, sample_count);
}

#elif !(defined(RTI_VXWORKS) && !defined(__RTP__)) && !defined(RTI_PSOS)
int main(int argc, char *argv[])
{
	int domainId = 0;
	int sample_count = 0;

	bool bDomainChanged(false);
	bool bSampleCountChanged(false);

	bool bSuccess;
	etWinSvcMode etMode = WINSVC_SERVICE;

	HelloSvc Server(TEXT("HelloService"), TEXT(""));

	for (int i = 1; i < argc; i++ )
	{
		if ( (*argv[i] == '-') || (*argv[i] == '/') )
		{
			switch (*(argv[i]+1))
			{
			case 'i' :
				bSuccess = 
					Server.Create(TEXT("Hello Service DDS communication test service"), TEXT("C:\\TEMP\\HelloWorld_subscriber.exe"), 1);
				return bSuccess ? 0 : 1;
				break;

			case 'u':
				bSuccess = Server.Remove();
				return bSuccess ? 0 : 1;
				break;

			case 'd':
				etMode = WINSVC_CONSOLE;
				break;

			case 'D':
				bDomainChanged = true;
				break;

			case 's':
				bSampleCountChanged = true;
				break;

			default:
				break;
			}
		}
		else
		{
			if (bDomainChanged == true)
			{
				domainId = atoi(argv[i]);
				Server.SetDomainID(domainId);
				bDomainChanged = false;
			}
			else if (bSampleCountChanged == true)
			{
				sample_count = atoi(argv[i]);
				Server.SetSampleCount(sample_count);
				bSampleCountChanged = false;
			}
		}
	}

	// Set appropriate logfile
	if (etMode == WINSVC_SERVICE)
	Server.OpenLogFile( TEXT("C:\\TEMP\\") );

	// Start interferometry service
	bSuccess = Server.Start(etMode);

	return bSuccess ? 0 : 1;

}
#endif

